// Copyright (c) 2007-2013 Hartmut Kaiser
// Copyright (c) 2012-2013 Thomas Heller
//
// Distributed under the Boost Software License, Version 1.0. (See accompanying
// file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

// This file has been automatically generated using the Boost.Wave tool.
// Do not edit manually.


namespace hpx
{
    
    
    template <typename F>
    bool apply(threads::executor& sched, F && f)
    {
        sched.add(std::forward<F>(f), "hpx::apply");
        return false; 
    }
    template <typename F>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<F()>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(F && f)
    {
        threads::register_thread_nullary(
            util::deferred_call(
                std::forward<F>(f)
            ), "hpx::apply");
        return false; 
    }
    
    
    template <typename Action, typename BoundArgs>
    bool apply(hpx::util::detail::bound_action<Action, BoundArgs> const& bound)
    {
        return bound.apply();
    }
}
namespace hpx
{
    
    
    
    template <typename F, typename A0>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<
            F(A0)>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(threads::executor& sched, F && f,
        A0 && a0)
    {
        sched.add(
            util::deferred_call(
                std::forward<F>(f),
                std::forward<A0>( a0 )
            ), "hpx::apply");
        return false;
    }
    template <typename F, typename A0>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<
            F(A0)>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(F && f, A0 && a0)
    {
        threads::register_thread_nullary(
            util::deferred_call(
                std::forward<F>(f),
                std::forward<A0>( a0 )
            ), "hpx::apply");
        return false;
    }
    
    template <
        typename Action, typename BoundArgs
      , typename A0
    >
    bool apply(
        hpx::util::detail::bound_action<Action, BoundArgs> const& bound
      , A0 && a0
    )
    {
        return bound.apply(std::forward<A0>( a0 ));
    }
}
namespace hpx
{
    
    
    
    template <typename F, typename A0 , typename A1>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<
            F(A0 , A1)>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(threads::executor& sched, F && f,
        A0 && a0 , A1 && a1)
    {
        sched.add(
            util::deferred_call(
                std::forward<F>(f),
                std::forward<A0>( a0 ) , std::forward<A1>( a1 )
            ), "hpx::apply");
        return false;
    }
    template <typename F, typename A0 , typename A1>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<
            F(A0 , A1)>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(F && f, A0 && a0 , A1 && a1)
    {
        threads::register_thread_nullary(
            util::deferred_call(
                std::forward<F>(f),
                std::forward<A0>( a0 ) , std::forward<A1>( a1 )
            ), "hpx::apply");
        return false;
    }
    
    template <
        typename Action, typename BoundArgs
      , typename A0 , typename A1
    >
    bool apply(
        hpx::util::detail::bound_action<Action, BoundArgs> const& bound
      , A0 && a0 , A1 && a1
    )
    {
        return bound.apply(std::forward<A0>( a0 ) , std::forward<A1>( a1 ));
    }
}
namespace hpx
{
    
    
    
    template <typename F, typename A0 , typename A1 , typename A2>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<
            F(A0 , A1 , A2)>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(threads::executor& sched, F && f,
        A0 && a0 , A1 && a1 , A2 && a2)
    {
        sched.add(
            util::deferred_call(
                std::forward<F>(f),
                std::forward<A0>( a0 ) , std::forward<A1>( a1 ) , std::forward<A2>( a2 )
            ), "hpx::apply");
        return false;
    }
    template <typename F, typename A0 , typename A1 , typename A2>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<
            F(A0 , A1 , A2)>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(F && f, A0 && a0 , A1 && a1 , A2 && a2)
    {
        threads::register_thread_nullary(
            util::deferred_call(
                std::forward<F>(f),
                std::forward<A0>( a0 ) , std::forward<A1>( a1 ) , std::forward<A2>( a2 )
            ), "hpx::apply");
        return false;
    }
    
    template <
        typename Action, typename BoundArgs
      , typename A0 , typename A1 , typename A2
    >
    bool apply(
        hpx::util::detail::bound_action<Action, BoundArgs> const& bound
      , A0 && a0 , A1 && a1 , A2 && a2
    )
    {
        return bound.apply(std::forward<A0>( a0 ) , std::forward<A1>( a1 ) , std::forward<A2>( a2 ));
    }
}
namespace hpx
{
    
    
    
    template <typename F, typename A0 , typename A1 , typename A2 , typename A3>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<
            F(A0 , A1 , A2 , A3)>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(threads::executor& sched, F && f,
        A0 && a0 , A1 && a1 , A2 && a2 , A3 && a3)
    {
        sched.add(
            util::deferred_call(
                std::forward<F>(f),
                std::forward<A0>( a0 ) , std::forward<A1>( a1 ) , std::forward<A2>( a2 ) , std::forward<A3>( a3 )
            ), "hpx::apply");
        return false;
    }
    template <typename F, typename A0 , typename A1 , typename A2 , typename A3>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<
            F(A0 , A1 , A2 , A3)>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(F && f, A0 && a0 , A1 && a1 , A2 && a2 , A3 && a3)
    {
        threads::register_thread_nullary(
            util::deferred_call(
                std::forward<F>(f),
                std::forward<A0>( a0 ) , std::forward<A1>( a1 ) , std::forward<A2>( a2 ) , std::forward<A3>( a3 )
            ), "hpx::apply");
        return false;
    }
    
    template <
        typename Action, typename BoundArgs
      , typename A0 , typename A1 , typename A2 , typename A3
    >
    bool apply(
        hpx::util::detail::bound_action<Action, BoundArgs> const& bound
      , A0 && a0 , A1 && a1 , A2 && a2 , A3 && a3
    )
    {
        return bound.apply(std::forward<A0>( a0 ) , std::forward<A1>( a1 ) , std::forward<A2>( a2 ) , std::forward<A3>( a3 ));
    }
}
namespace hpx
{
    
    
    
    template <typename F, typename A0 , typename A1 , typename A2 , typename A3 , typename A4>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<
            F(A0 , A1 , A2 , A3 , A4)>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(threads::executor& sched, F && f,
        A0 && a0 , A1 && a1 , A2 && a2 , A3 && a3 , A4 && a4)
    {
        sched.add(
            util::deferred_call(
                std::forward<F>(f),
                std::forward<A0>( a0 ) , std::forward<A1>( a1 ) , std::forward<A2>( a2 ) , std::forward<A3>( a3 ) , std::forward<A4>( a4 )
            ), "hpx::apply");
        return false;
    }
    template <typename F, typename A0 , typename A1 , typename A2 , typename A3 , typename A4>
    typename boost::enable_if_c<
        traits::detail::is_callable_not_action<
            F(A0 , A1 , A2 , A3 , A4)>::value
     && !traits::is_bound_action<typename util::decay<F>::type>::value
      , bool
    >::type
    apply(F && f, A0 && a0 , A1 && a1 , A2 && a2 , A3 && a3 , A4 && a4)
    {
        threads::register_thread_nullary(
            util::deferred_call(
                std::forward<F>(f),
                std::forward<A0>( a0 ) , std::forward<A1>( a1 ) , std::forward<A2>( a2 ) , std::forward<A3>( a3 ) , std::forward<A4>( a4 )
            ), "hpx::apply");
        return false;
    }
    
    template <
        typename Action, typename BoundArgs
      , typename A0 , typename A1 , typename A2 , typename A3 , typename A4
    >
    bool apply(
        hpx::util::detail::bound_action<Action, BoundArgs> const& bound
      , A0 && a0 , A1 && a1 , A2 && a2 , A3 && a3 , A4 && a4
    )
    {
        return bound.apply(std::forward<A0>( a0 ) , std::forward<A1>( a1 ) , std::forward<A2>( a2 ) , std::forward<A3>( a3 ) , std::forward<A4>( a4 ));
    }
}
