// Boost Logging library
//
// Author: John Torjo, www.torjo.com
//
// Copyright (C) 2007 John Torjo (see www.torjo.com for email)
//
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)
//
// See http://www.boost.org for updates, documentation, and revision history.
// See http://www.torjo.com/log2/ for more details

namespace hpx { namespace util { namespace logging {

/**
@mainpage Boost Logging Library v2 - Table of contents


- @ref main_intro
    - @ref main_motivation
    - @ref main_feeback
    - @ref page_changelog
        - @ref changelog_cur_ver
    - @ref acknowledgements
    - @ref breaking_changes
      - @ref breaking_change_v_20
    - @ref misc_compilers
    - @ref misc_bjam

- @ref getting_started

- @ref workflow
    - @ref workflow_introduction
    - @ref workflow_filter
    - @ref workflow_processing
    - @ref workflow_2a
    - @ref workflow_2b
    - @ref workflow_formatters_destinations

- @ref common_scenarios
    - @ref common_scenarios_1
    - @ref common_scenarios_5
    - @ref common_scenarios_6
    - @ref common_your_scenario
    - @ref scenario_multiple_files
    - @ref starter_project


\n
@section log_tutorial Tutorial

    - @ref headers_to_include "Headers to #include"
    - @ref defining_your_logger_filter
    - @ref defining_logger_macros
    - @ref scenario::usage "Choose the best filter/logger class, based on your application's needs"
    - @ref scoped_logs
    - @ref tag "Using tags"
    - @ref profile "Profiling - computing the time spent while logging"



\n
@section special_cases Special Cases

    - @ref caching
    - @ref after_destruction

\n
@section advanced_concepts Advanced concepts

- @ref thread_safety
- @ref misc_unicode
- @ref macros
    - @ref macros_if_else_strategy
    - @ref macros_using
        - @ref macros_define_declare
        - @ref macros_use
        - @ref macros_set_formatters
        - @ref macros_use_tags
        - @ref macros_compile_time
        - @ref macros_tss

- @ref logger "The logger class"
    - @ref gather "The gather namespace"
    - @ref writer "The writer namespace"
- @ref filter "The filters (namespace)"
- @ref namespace_concepts
    - @ref namespace_general
    - @ref namespace_process
    - @ref namespace_manipulator
    - @ref namespace_write
- @ref manipulator "Formatters and/or destinations (manipulators namespace)"
    - @ref manipulator_common
    - @ref manipulator_base_class
    - @ref manipulator_default_base_class
    - @ref manipulator_generic
    - @ref manipulator_create
    - @ref manipulator_share_data
    - @ref manipulator_manipulate "Modifying a formatter's state"
    - @ref manipulator_manipulate "Modifying a destination's state"
    - @ref formatter "Formatters"
    - @ref destination "Destinations"

- @ref HPX_LOGGING_requirements
- @ref page_todo
- @ref rationale
- @ref known_issues

*/

}}}
